/***********************************************
*  ACM1602N1-FLW-FBW t\탉Cu
*  I2CC^[tF[X
*    lcd_init()    ----- 
*    lcd_cmd(cmd)  ----- R}ho
*    lcd_data(data) ----- P\o
*    lcd_str(ptr)  ----- \o
*    lcd_clear()   ----- S
*    lcd_home()   ----- J[\z[
**********************************************/
#include <xc.h>
#include "lcd_lib2.h"
#include "i2c_lib2.h"

/*********************************
* t1\f[^o
*********************************/
void lcd_data(unsigned char data)
{
    CmdI2C(0xA0, 0x80, data);   // ACM1602N1-FLW-FBW Slave address:1010000+0 = A0
    __delay_us(30);				// u҂
}

/*******************************
* tւPR}ho
*******************************/
void lcd_cmd(unsigned char cmd)
{
    CmdI2C(0xA0, 0x00, cmd);    // ACM1602N1-FLW-FBW Slave address:1010000+0 = A0
    /* ClearHome */
    if((cmd == 0x01)||(cmd == 0x02))
        __delay_ms(2);			// 2msec҂
    else
        __delay_us(30);			// 30usec҂
}

/*******************************
*  ֐
*******************************/
void lcd_init(void)
{
    __delay_ms(100);
    lcd_cmd(0x38);              // 8bit 2line Normal mode
    lcd_cmd(0x0C);              // Display On Cursor=0 Blink=0
    lcd_cmd(0x06);              // Entry mode set:Entry Inc/Dec=1 Shift=0
    lcd_cmd(0x01);              // Clear Display
}

/******************************
* S֐
******************************/
void lcd_clear(void)
{
    lcd_cmd(0x01);              // R}ho
}

/*****************************
* \֐
*****************************/
void lcd_str(const unsigned char* ptr)
{
    while(*ptr != 0)			// o
        lcd_data(*ptr++);		// \
}

/*****************************
*  J[\z[
*****************************/
void lcd_home(void)
{
    lcd_cmd(0x02);
}
