/**
  Generated Main Source File
    12F1840_Color_Sensor

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC12F1840
        Driver Version    :  2.00
        Color Sensor      :  S11059-02DT module
        LCD               :  ACM1602NI-FLW-FBW-M01
 
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "lcd_lib2.h"
#include "i2c_lib2.h"
#include "i2c-lib.h"

#define S11059_ADRS 0x54         // ZT[X[uAhX`:0b0101010(0x2A)+0 = 0b01010100 = 0x54 

// O[oϐ錾
unsigned long Red,Green,Blue,IR;    // 16 bitJ[f[^(Red:,Green:,Blue:,IR:ԊO)
unsigned long data[7];           // ZT[Mf[^i[p

// vg^CsO錾
void S11059(void);              // ZT[֐

// Wo͊֐p჌x֐`
void putch(unsigned char data) {
    lcd_data(data);                 // t\Wo͊֐Ƃ    
}

/*
    Main application
 */

void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();          // O[o荞݋

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();      // ӊ荞݋

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    // foCX    
    lcd_init();                 // LCD        

    while (1)
    {
        // Add your application code
        
        S11059();             // ZT[֐Ăяo 
        
        // LCDo
        lcd_cmd(0x80);                      // LCD1s
            printf("R:%5lu  G:%5lu",Red,Green);  // %lu:{x10i 
            
        lcd_cmd(0xC0);                      // LCD2s
            printf("B:%5lu  IR:%4lu",Blue,IR);  // %lu:{x10i
            
        __delay_ms(500);           // 0.5 sec          
     
    }
}

// ZT[֐
void S11059(void) {

    unsigned int i;

// R}hM    
    i2c_start();                        // I2CX^[gRfBVs        
    i2c_send_byte(S11059_ADRS);         // X[uID + 0(ݗv)w
    i2c_send_byte(0x00);                // Rg[WX^[(0x00)w
    i2c_send_byte(0x8A);                // 0b10001010 (ADCZbg/X[v/HighQC/ϕ[h:Œ/ϕ:22.4ms)
//    i2c_send_byte(0x82);                // 0b10000010 (ADCZbg/X[v/LowQC/ϕ[h:Œ/ϕ:22.4ms)
    i2c_start();                        // I2CX^[gRfBVs
    i2c_send_byte(S11059_ADRS);         // X[uID + 0(ݗv)w
    i2c_send_byte(0x00);                // Rg[WX^[(0x00)w
    i2c_send_byte(0x0A);                // 0b00001010 (ADCZbg/oX[X/HighQC/ϕ[h:Œ/ϕ:22.4ms)
    i2c_stop();                         // I2CXgbvRfBVs     

    __delay_ms(50);                    // f[^ANCWV (*ϕԈȏ̂)       

// f[^擾      
    i2c_start();                        // I2CX^[gRfBVs        
    i2c_send_byte(S11059_ADRS);         // X[uID + 0(ݗv)w
    i2c_send_byte(0x03);                // f[^ǂݍ݊JnAhX(0x03)w    
    i2c_start();                        // I2CX^[gRfBVs        
    i2c_send_byte(S11059_ADRS + 1);     // X[uID + 1(ǂݍݗv)
    for (i=0; i<8; i++) {               // f[^擾
        if (i==7)
            data[7] = i2c_read_byte(0);     // ŏIWX^MNACK
        else
            data[i] = i2c_read_byte(1);     // ȊOACKԂ   
    }
    i2c_stop();                         // I2CXgbvRfBVs     

// f[^    
    Red = (data[0] << 8) | data[1];          // Red 8 bit+8bit  
    Green = (data[2] << 8) | data[3];       // Green 8 bit+8bit 
    Blue = (data[4] << 8) | data[5];        // Red 8 bit+8bit 
    IR = (data[6] << 8) | data[7];          // IR 8 bit+8bit     
    
}

/**
 End of File
*/